testqsort.c File Reference
`#include "SDL_test.h"`
Include dependency graph for testqsort.c:

Go to the source code of this file.

## Functions

static int | num_compare (const void *_a, const void *_b)
static void | test_sort (const char *desc, int *nums, const int arraylen)
int | main (int argc, char *argv[])

## Function Documentation

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 45 of file testqsort.c.

References SDLTest_RandomContext::c, i, iteration(), SDL_arraysize, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LogError, SDL_sscanf, SDLTest_RandomInit(), SDLTest_RandomInitTime(), SDLTest_RandomInt, test_sort(), and SDLTest_RandomContext::x.

{
static int nums[1024 * 100];
static const int itervals[] = { SDL_arraysize(nums), 12 };
int iteration;
SDLTest_RandomContext rndctx;
if (argc > 1)
{
int success;
Uint64 seed = 0;
if (argv[1][0] == '0' && argv[1][1] == 'x')
success = SDL_sscanf(argv[1] + 2, "%llx", &seed);
else
success = SDL_sscanf(argv[1], "%llu", &seed);
if (!success)
{
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Invalid seed. Use a decimal or hexadecimal number.\n");
return 1;
}
if (seed <= 0xffffffff)
{
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Seed must be equal or greater than 0x100000000.\n");
return 1;
}
SDLTest_RandomInit(&rndctx, (unsigned int)(seed >> 32), (unsigned int)(seed & 0xffffffff));
}
else
{
SDLTest_RandomInitTime(&rndctx);
}
SDL_Log("Using random seed 0x%08x%08x\n", rndctx.x, rndctx.c);
for (iteration = 0; iteration < SDL_arraysize(itervals); iteration++) {
const int arraylen = itervals[iteration];
int i;
for (i = 0; i < arraylen; i++) {
nums[i] = i;
}
test_sort("already sorted", nums, arraylen);
for (i = 0; i < arraylen; i++) {
nums[i] = i;
}
nums[arraylen-1] = -1;
test_sort("already sorted except last element", nums, arraylen);
for (i = 0; i < arraylen; i++) {
nums[i] = (arraylen-1) - i;
}
test_sort("reverse sorted", nums, arraylen);
for (i = 0; i < arraylen; i++) {
nums[i] = SDLTest_RandomInt(&rndctx);
}
test_sort("random sorted", nums, arraylen);
}
return 0;
}
test_sort
static void test_sort(const char *desc, int *nums, const int arraylen)
Definition: testqsort.c:24
Uint64
uint64_t Uint64
Definition: SDL_stdinc.h:194
SDLTest_RandomInit
void SDLTest_RandomInit(SDLTest_RandomContext *rndContext, unsigned int xi, unsigned int ci)
Initialize random number generator with two integers.
Definition: SDL_test_random.c:41
iteration
static void iteration()
Definition: testaudiohotplug.c:84
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
SDLTest_RandomContext::c
unsigned int c
Definition: SDL_test_random.h:62
SDLTest_RandomInitTime
void SDLTest_RandomInitTime(SDLTest_RandomContext *rndContext)
Initialize random number generator based on current system time.
Definition: SDL_test_random.c:65
SDLTest_RandomContext::x
unsigned int x
Definition: SDL_test_random.h:61
SDL_sscanf
#define SDL_sscanf
Definition: SDL_dynapi_overrides.h:39
SDLTest_RandomContext
Definition: SDL_test_random.h:59
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDLTest_RandomInt
#define SDLTest_RandomInt(c)
Definition: SDL_test_random.h:54
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66

## num_compare()

static int num_compare | ( | const void * | _a,
|  | const void * | _b
| ) |  |

static

Definition at line 16 of file testqsort.c.

Referenced by test_sort().

{
const int a = *((const int *) _a);
const int b = *((const int *) _b);
return (a < b) ? -1 : ((a > b) ? 1 : 0);
}
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109

## test_sort()

static void test_sort | ( | const char * | desc,
|  | int * | nums,
|  | const int | arraylen
| ) |  |

static

Definition at line 24 of file testqsort.c.

References i, num_compare(), SDL_Log, and SDL_qsort.

Referenced by main().

{
int i;
int prev;
SDL_Log("test: %s arraylen=%d", desc, arraylen);
SDL_qsort(nums, arraylen, sizeof (nums[0]), num_compare);
prev = nums[0];
for (i = 1; i < arraylen; i++) {
const int val = nums[i];
if (val < prev) {
SDL_Log("sort is broken!");
return;
}
prev = val;
}
}
SDL_qsort
#define SDL_qsort
Definition: SDL_dynapi_overrides.h:380
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
val
GLuint GLfloat * val
Definition: SDL_opengl_glext.h:1492
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
num_compare
static int num_compare(const void *_a, const void *_b)
Definition: testqsort.c:16